#! /usr/bin/env node

const shell = require("shelljs");
const REPO = "https://github.com/D-Mobilelab/dml-js-boilerplate.git"

var modulename = process.argv[2];
var exit;

// 1) clone repository 'js-boilerplate' to new directory
console.log(`Cloning ${REPO} to ${modulename}...`);
exit = shell.exec(["git clone", REPO, modulename].join(" "));
if(exit.code !== 0){
	console.log("Not possible to clone " + REPO);
	process.exit(exit.code);
}

// 2) Change directory
console.log(`Changing dir to ${modulename}...`);
exit = shell.cd(modulename);
if(exit.code !== 0){
	console.log("Not possible to change dir to " + modulename);
	process.exit(exit.code);
}

// 3) delete .git folder
console.log(`Deleting .git folder in ${modulename}...`);
exit = shell.rm("-rf",".git");
if(exit.code !== 0){
	console.log("Not possible to delete .git folder in " + modulename);
	process.exit(exit.code);
}

// 4) replace your_library string to module name
console.log(`Renaming library name to ${modulename}...`);
['bower.json', 'package-new.json', 'README-new.md'].forEach(function(file) {
  exit = shell.sed('-i', 'your_library', modulename, file);
});
if(exit.code !== 0){
	console.log("Not possible to rename library name to " + modulename);
	process.exit(exit.code);
}

// 5) overwrite readme file
console.log(`Overwrite readme...`);
exit = shell.mv("README-new.md", "README.md");
if(exit.code !== 0){
	console.log("Not possible to overwrite readme");
	process.exit(exit.code);
}

// 6) overwrite package.json file
console.log(`Overwrite package.json...`);
exit = shell.mv("package-new.json", "package.json");
if(exit.code !== 0){
	console.log("Not possible to overwrite package.json");
	process.exit(exit.code);
}

// 7) overwrite package.json file
console.log(`Overwrite eslintrc...`);
exit = shell.mv(".eslintrc-new", ".eslintrc");
if(exit.code !== 0){
	console.log("Not possible to overwrite eslintrc");
	process.exit(exit.code);
}

// 8) overwrite Gruntfile file
console.log(`Overwrite Gruntfile...`);
exit = shell.mv("Gruntfile-new.js", "Gruntfile.js");
if(exit.code !== 0){
	console.log("Not possible to overwrite Gruntfile");
	process.exit(exit.code);
} else {
	console.log("Your library is ready!");
	process.exit(exit.code);
}

// console.log(`Installing node modules in ${modulename}...`);
// exit = shell.exec("npm install");
// if(exit.code !== 0){
// 	console.log("Not possible to install node modules");
// 	process.exit(exit.code);
// }